%%% File    : client.erl
%%% Author  : Clara Benac Earle <clara@bacardi>
%%% Purpose : 
%%% Created : 12 Apr 2001 by Clara Benac Earle <clara@bacardi>
%%% Modified: 08 Jun 2001 by Thomas Arts <thomas@cslab.ericsson.se>

-module(client).
-author('clara@bacardi').

-export([start_link/3, init/3]).

start_link(Locker,Resources,Type) ->   
    {ok,spawn_link(?MODULE, init, [Locker,Resources,Type])}.

init(Locker,Resources,Type) ->
    loop(Locker,Resources,Type).

loop(Locker,Resources,Type) ->
    gen_server:call(Locker, {request,Resources,Type}),
    %
    % this is the critical section
    %
    gen_server:call(Locker, release),
    loop(Locker,Resources,Type).

